# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class AttributeCombinatorSpec(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'method': 'str',
        'operations': 'list[object]'
    }

    attribute_map = {
        'method': 'method',
        'operations': 'operations'
    }

    def __init__(self, method=None, operations=None, local_vars_configuration=None):  # noqa: E501
        """AttributeCombinatorSpec - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._method = None
        self._operations = None
        self.discriminator = None

        if method is not None:
            self.method = method
        if operations is not None:
            self.operations = operations

    @property
    def method(self):
        """
        Method to combine 

        :return: The method of this AttributeCombinatorSpec. 
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """
        Method to combine 

        :param method: The method of this AttributeCombinatorSpec.
        :type: str
        """
        allowed_values = ["and", "or", "not"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and method not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `method` ({0}), must be one of {1}"  # noqa: E501
                .format(method, allowed_values)
            )

        self._method = method

    @property
    def operations(self):
        """
        Must be a AttributeOperationSpec!

        :return: The operations of this AttributeCombinatorSpec. 
        :rtype: list[object]
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """
        Must be a AttributeOperationSpec!

        :param operations: The operations of this AttributeCombinatorSpec.
        :type: list[object]
        """

        self._operations = operations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AttributeCombinatorSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AttributeCombinatorSpec):
            return True

        return self.to_dict() != other.to_dict()
