# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class Bucket(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'archive_sc': 'str',
        'endpoint_url': 'str',
        'external_host': 'str',
        'id': 'int',
        'live_sc': 'str',
        'name': 'str',
        'organization': 'int',
        'store_type': 'str'
    }

    attribute_map = {
        'archive_sc': 'archive_sc',
        'endpoint_url': 'endpoint_url',
        'external_host': 'external_host',
        'id': 'id',
        'live_sc': 'live_sc',
        'name': 'name',
        'organization': 'organization',
        'store_type': 'store_type'
    }

    def __init__(self, archive_sc=None, endpoint_url=None, external_host=None, id=None, live_sc=None, name=None, organization=None, store_type=None, local_vars_configuration=None):  # noqa: E501
        """Bucket - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._archive_sc = None
        self._endpoint_url = None
        self._external_host = None
        self._id = None
        self._live_sc = None
        self._name = None
        self._organization = None
        self._store_type = None
        self.discriminator = None

        if archive_sc is not None:
            self.archive_sc = archive_sc
        if endpoint_url is not None:
            self.endpoint_url = endpoint_url
        if external_host is not None:
            self.external_host = external_host
        if id is not None:
            self.id = id
        if live_sc is not None:
            self.live_sc = live_sc
        if name is not None:
            self.name = name
        if organization is not None:
            self.organization = organization
        if store_type is not None:
            self.store_type = store_type

    @property
    def archive_sc(self):
        """
        Storage class in which archived objects live.

        :return: The archive_sc of this Bucket. 
        :rtype: str
        """
        return self._archive_sc

    @archive_sc.setter
    def archive_sc(self, archive_sc):
        """
        Storage class in which archived objects live.

        :param archive_sc: The archive_sc of this Bucket.
        :type: str
        """
        allowed_values = ["STANDARD", "DEEP_ARCHIVE", "COLDLINE"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and archive_sc not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `archive_sc` ({0}), must be one of {1}"  # noqa: E501
                .format(archive_sc, allowed_values)
            )

        self._archive_sc = archive_sc

    @property
    def endpoint_url(self):
        """
        Endpoint URL for bucket.

        :return: The endpoint_url of this Bucket. 
        :rtype: str
        """
        return self._endpoint_url

    @endpoint_url.setter
    def endpoint_url(self, endpoint_url):
        """
        Endpoint URL for bucket.

        :param endpoint_url: The endpoint_url of this Bucket.
        :type: str
        """

        self._endpoint_url = endpoint_url

    @property
    def external_host(self):
        """
        The proxy host for presigned urls.

        :return: The external_host of this Bucket. 
        :rtype: str
        """
        return self._external_host

    @external_host.setter
    def external_host(self, external_host):
        """
        The proxy host for presigned urls.

        :param external_host: The external_host of this Bucket.
        :type: str
        """

        self._external_host = external_host

    @property
    def id(self):
        """
        Unique integer identifying a bucket.

        :return: The id of this Bucket. 
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Unique integer identifying a bucket.

        :param id: The id of this Bucket.
        :type: int
        """

        self._id = id

    @property
    def live_sc(self):
        """
        Storage class in which live objects live.

        :return: The live_sc of this Bucket. 
        :rtype: str
        """
        return self._live_sc

    @live_sc.setter
    def live_sc(self, live_sc):
        """
        Storage class in which live objects live.

        :param live_sc: The live_sc of this Bucket.
        :type: str
        """
        allowed_values = ["STANDARD"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and live_sc not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `live_sc` ({0}), must be one of {1}"  # noqa: E501
                .format(live_sc, allowed_values)
            )

        self._live_sc = live_sc

    @property
    def name(self):
        """
        Bucket name.

        :return: The name of this Bucket. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Bucket name.

        :param name: The name of this Bucket.
        :type: str
        """

        self._name = name

    @property
    def organization(self):
        """
        Unique integer identifying organization that owns this bucket.

        :return: The organization of this Bucket. 
        :rtype: int
        """
        return self._organization

    @organization.setter
    def organization(self, organization):
        """
        Unique integer identifying organization that owns this bucket.

        :param organization: The organization of this Bucket.
        :type: int
        """

        self._organization = organization

    @property
    def store_type(self):
        """
        Type of object store on which the bucket is hosted.

        :return: The store_type of this Bucket. 
        :rtype: str
        """
        return self._store_type

    @store_type.setter
    def store_type(self, store_type):
        """
        Type of object store on which the bucket is hosted.

        :param store_type: The store_type of this Bucket.
        :type: str
        """
        allowed_values = ["AWS", "MINIO", "GCP", "OCI"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and store_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `store_type` ({0}), must be one of {1}"  # noqa: E501
                .format(store_type, allowed_values)
            )

        self._store_type = store_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Bucket):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Bucket):
            return True

        return self.to_dict() != other.to_dict()
