# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class FileSpec(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'description': 'str',
        'elemental_id': 'str',
        'name': 'str',
        'type': 'int',
        'user_elemental_id': 'str'
    }

    attribute_map = {
        'attributes': 'attributes',
        'description': 'description',
        'elemental_id': 'elemental_id',
        'name': 'name',
        'type': 'type',
        'user_elemental_id': 'user_elemental_id'
    }

    def __init__(self, attributes=None, description=None, elemental_id=None, name=None, type=None, user_elemental_id=None, local_vars_configuration=None):  # noqa: E501
        """FileSpec - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._description = None
        self._elemental_id = None
        self._name = None
        self._type = None
        self._user_elemental_id = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if description is not None:
            self.description = description
        self.elemental_id = elemental_id
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type
        self.user_elemental_id = user_elemental_id

    @property
    def attributes(self):
        """
        Object containing attribute values

        :return: The attributes of this FileSpec. 
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Object containing attribute values

        :param attributes: The attributes of this FileSpec.
        :type: dict(str, object)
        """

        self._attributes = attributes

    @property
    def description(self):
        """
        Description of file

        :return: The description of this FileSpec. 
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Description of file

        :param description: The description of this FileSpec.
        :type: str
        """

        self._description = description

    @property
    def elemental_id(self):
        """
        The elemental ID of the object.

        :return: The elemental_id of this FileSpec. 
        :rtype: str
        """
        return self._elemental_id

    @elemental_id.setter
    def elemental_id(self, elemental_id):
        """
        The elemental ID of the object.

        :param elemental_id: The elemental_id of this FileSpec.
        :type: str
        """

        self._elemental_id = elemental_id

    @property
    def name(self):
        """
        Name of file

        :return: The name of this FileSpec. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Name of file

        :param name: The name of this FileSpec.
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """
        Unique integer identifying FileType of this File object.

        :return: The type of this FileSpec. 
        :rtype: int
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Unique integer identifying FileType of this File object.

        :param type: The type of this FileSpec.
        :type: int
        """

        self._type = type

    @property
    def user_elemental_id(self):
        """
        The elemental ID of the object.

        :return: The user_elemental_id of this FileSpec. 
        :rtype: str
        """
        return self._user_elemental_id

    @user_elemental_id.setter
    def user_elemental_id(self, user_elemental_id):
        """
        The elemental ID of the object.

        :param user_elemental_id: The user_elemental_id of this FileSpec.
        :type: str
        """

        self._user_elemental_id = user_elemental_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FileSpec):
            return True

        return self.to_dict() != other.to_dict()
