# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class FileTypeSpec(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attribute_types': 'list[AttributeType]',
        'description': 'str',
        'elemental_id': 'str',
        'name': 'str'
    }

    attribute_map = {
        'attribute_types': 'attribute_types',
        'description': 'description',
        'elemental_id': 'elemental_id',
        'name': 'name'
    }

    def __init__(self, attribute_types=None, description='', elemental_id=None, name=None, local_vars_configuration=None):  # noqa: E501
        """FileTypeSpec - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attribute_types = None
        self._description = None
        self._elemental_id = None
        self._name = None
        self.discriminator = None

        if attribute_types is not None:
            self.attribute_types = attribute_types
        if description is not None:
            self.description = description
        self.elemental_id = elemental_id
        if name is not None:
            self.name = name

    @property
    def attribute_types(self):
        """
        Attribute type definitions.

        :return: The attribute_types of this FileTypeSpec. 
        :rtype: list[AttributeType]
        """
        return self._attribute_types

    @attribute_types.setter
    def attribute_types(self, attribute_types):
        """
        Attribute type definitions.

        :param attribute_types: The attribute_types of this FileTypeSpec.
        :type: list[AttributeType]
        """

        self._attribute_types = attribute_types

    @property
    def description(self):
        """
        Description of the file type.

        :return: The description of this FileTypeSpec. 
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Description of the file type.

        :param description: The description of this FileTypeSpec.
        :type: str
        """

        self._description = description

    @property
    def elemental_id(self):
        """
        The elemental ID of the object.

        :return: The elemental_id of this FileTypeSpec. 
        :rtype: str
        """
        return self._elemental_id

    @elemental_id.setter
    def elemental_id(self, elemental_id):
        """
        The elemental ID of the object.

        :param elemental_id: The elemental_id of this FileTypeSpec.
        :type: str
        """

        self._elemental_id = elemental_id

    @property
    def name(self):
        """
        Name of the file type.

        :return: The name of this FileTypeSpec. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Name of the file type.

        :param name: The name of this FileTypeSpec.
        :type: str
        """

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileTypeSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FileTypeSpec):
            return True

        return self.to_dict() != other.to_dict()
