# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class FileUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'description': 'str',
        'elemental_id': 'str',
        'name': 'str',
        'null_attributes': 'list[str]',
        'path': 'str',
        'reset_attributes': 'list[str]',
        'type': 'int'
    }

    attribute_map = {
        'attributes': 'attributes',
        'description': 'description',
        'elemental_id': 'elemental_id',
        'name': 'name',
        'null_attributes': 'null_attributes',
        'path': 'path',
        'reset_attributes': 'reset_attributes',
        'type': 'type'
    }

    def __init__(self, attributes=None, description=None, elemental_id=None, name=None, null_attributes=None, path=None, reset_attributes=None, type=None, local_vars_configuration=None):  # noqa: E501
        """FileUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._description = None
        self._elemental_id = None
        self._name = None
        self._null_attributes = None
        self._path = None
        self._reset_attributes = None
        self._type = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if description is not None:
            self.description = description
        self.elemental_id = elemental_id
        if name is not None:
            self.name = name
        if null_attributes is not None:
            self.null_attributes = null_attributes
        if path is not None:
            self.path = path
        if reset_attributes is not None:
            self.reset_attributes = reset_attributes
        if type is not None:
            self.type = type

    @property
    def attributes(self):
        """
        Object containing attribute values

        :return: The attributes of this FileUpdate. 
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Object containing attribute values

        :param attributes: The attributes of this FileUpdate.
        :type: dict(str, object)
        """

        self._attributes = attributes

    @property
    def description(self):
        """
        Description of file

        :return: The description of this FileUpdate. 
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Description of file

        :param description: The description of this FileUpdate.
        :type: str
        """

        self._description = description

    @property
    def elemental_id(self):
        """
        The elemental ID of the object.

        :return: The elemental_id of this FileUpdate. 
        :rtype: str
        """
        return self._elemental_id

    @elemental_id.setter
    def elemental_id(self, elemental_id):
        """
        The elemental ID of the object.

        :param elemental_id: The elemental_id of this FileUpdate.
        :type: str
        """

        self._elemental_id = elemental_id

    @property
    def name(self):
        """
        Name of file

        :return: The name of this FileUpdate. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Name of file

        :param name: The name of this FileUpdate.
        :type: str
        """

        self._name = name

    @property
    def null_attributes(self):
        """
        Null a value in the attributes body

        :return: The null_attributes of this FileUpdate. 
        :rtype: list[str]
        """
        return self._null_attributes

    @null_attributes.setter
    def null_attributes(self, null_attributes):
        """
        Null a value in the attributes body

        :param null_attributes: The null_attributes of this FileUpdate.
        :type: list[str]
        """

        self._null_attributes = null_attributes

    @property
    def path(self):
        """
        Relative URL to the file

        :return: The path of this FileUpdate. 
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Relative URL to the file

        :param path: The path of this FileUpdate.
        :type: str
        """

        self._path = path

    @property
    def reset_attributes(self):
        """
        Reset an attribute to the default value specified in the Type object

        :return: The reset_attributes of this FileUpdate. 
        :rtype: list[str]
        """
        return self._reset_attributes

    @reset_attributes.setter
    def reset_attributes(self, reset_attributes):
        """
        Reset an attribute to the default value specified in the Type object

        :param reset_attributes: The reset_attributes of this FileUpdate.
        :type: list[str]
        """

        self._reset_attributes = reset_attributes

    @property
    def type(self):
        """
        Unique integer identifying FileType of this File object.

        :return: The type of this FileUpdate. 
        :rtype: int
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Unique integer identifying FileType of this File object.

        :param type: The type of this FileUpdate.
        :type: int
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FileUpdate):
            return True

        return self.to_dict() != other.to_dict()
