# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class LeafBulkUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'float_array': 'list[FloatArrayQuery]',
        'ids': 'list[int]',
        'null_attributes': 'list[str]',
        'object_search': 'AttributeOperationSpec',
        'reset_attributes': 'list[str]'
    }

    attribute_map = {
        'attributes': 'attributes',
        'float_array': 'float_array',
        'ids': 'ids',
        'null_attributes': 'null_attributes',
        'object_search': 'object_search',
        'reset_attributes': 'reset_attributes'
    }

    def __init__(self, attributes=None, float_array=None, ids=None, null_attributes=None, object_search=None, reset_attributes=None, local_vars_configuration=None):  # noqa: E501
        """LeafBulkUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._float_array = None
        self._ids = None
        self._null_attributes = None
        self._object_search = None
        self._reset_attributes = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if float_array is not None:
            self.float_array = float_array
        if ids is not None:
            self.ids = ids
        if null_attributes is not None:
            self.null_attributes = null_attributes
        if object_search is not None:
            self.object_search = object_search
        if reset_attributes is not None:
            self.reset_attributes = reset_attributes

    @property
    def attributes(self):
        """
        Attribute values to bulk update an entity list.

        :return: The attributes of this LeafBulkUpdate. 
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Attribute values to bulk update an entity list.

        :param attributes: The attributes of this LeafBulkUpdate.
        :type: dict(str, object)
        """

        self._attributes = attributes

    @property
    def float_array(self):
        """
        Searches on `float_array` attributes.

        :return: The float_array of this LeafBulkUpdate. 
        :rtype: list[FloatArrayQuery]
        """
        return self._float_array

    @float_array.setter
    def float_array(self, float_array):
        """
        Searches on `float_array` attributes.

        :param float_array: The float_array of this LeafBulkUpdate.
        :type: list[FloatArrayQuery]
        """

        self._float_array = float_array

    @property
    def ids(self):
        """
        Array of leaf IDs to retrieve.

        :return: The ids of this LeafBulkUpdate. 
        :rtype: list[int]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """
        Array of leaf IDs to retrieve.

        :param ids: The ids of this LeafBulkUpdate.
        :type: list[int]
        """

        self._ids = ids

    @property
    def null_attributes(self):
        """
        Null a value in the attributes body

        :return: The null_attributes of this LeafBulkUpdate. 
        :rtype: list[str]
        """
        return self._null_attributes

    @null_attributes.setter
    def null_attributes(self, null_attributes):
        """
        Null a value in the attributes body

        :param null_attributes: The null_attributes of this LeafBulkUpdate.
        :type: list[str]
        """

        self._null_attributes = null_attributes

    @property
    def object_search(self):
        """

        :return: The object_search of this LeafBulkUpdate. 
        :rtype: AttributeOperationSpec
        """
        return self._object_search

    @object_search.setter
    def object_search(self, object_search):
        """

        :param object_search: The object_search of this LeafBulkUpdate.
        :type: AttributeOperationSpec
        """

        self._object_search = object_search

    @property
    def reset_attributes(self):
        """
        Reset an attribute to the default value specified in the Type object

        :return: The reset_attributes of this LeafBulkUpdate. 
        :rtype: list[str]
        """
        return self._reset_attributes

    @reset_attributes.setter
    def reset_attributes(self, reset_attributes):
        """
        Reset an attribute to the default value specified in the Type object

        :param reset_attributes: The reset_attributes of this LeafBulkUpdate.
        :type: list[str]
        """

        self._reset_attributes = reset_attributes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LeafBulkUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LeafBulkUpdate):
            return True

        return self.to_dict() != other.to_dict()
