# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class LeafSuggestion(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data': 'dict(str, object)',
        'group': 'str',
        'value': 'str'
    }

    attribute_map = {
        'data': 'data',
        'group': 'group',
        'value': 'value'
    }

    def __init__(self, data=None, group=None, value=None, local_vars_configuration=None):  # noqa: E501
        """LeafSuggestion - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._data = None
        self._group = None
        self._value = None
        self.discriminator = None

        if data is not None:
            self.data = data
        if group is not None:
            self.group = group
        if value is not None:
            self.value = value

    @property
    def data(self):
        """
        Auxiliary data associated with the leaf.

        :return: The data of this LeafSuggestion. 
        :rtype: dict(str, object)
        """
        return self._data

    @data.setter
    def data(self, data):
        """
        Auxiliary data associated with the leaf.

        :param data: The data of this LeafSuggestion.
        :type: dict(str, object)
        """

        self._data = data

    @property
    def group(self):
        """
        Group of the suggestion.

        :return: The group of this LeafSuggestion. 
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Group of the suggestion.

        :param group: The group of this LeafSuggestion.
        :type: str
        """

        self._group = group

    @property
    def value(self):
        """
        Name of the suggestion.

        :return: The value of this LeafSuggestion. 
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Name of the suggestion.

        :param value: The value of this LeafSuggestion.
        :type: str
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LeafSuggestion):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LeafSuggestion):
            return True

        return self.to_dict() != other.to_dict()
