# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class LocalizationBulkUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'float_array': 'list[FloatArrayQuery]',
        'ids': 'list[int]',
        'media_ids': 'list[int]',
        'media_query': 'str',
        'new_elemental_id': 'str',
        'new_version': 'int',
        'object_search': 'AttributeOperationSpec',
        'state_ids': 'list[int]',
        'user_elemental_id': 'str'
    }

    attribute_map = {
        'attributes': 'attributes',
        'float_array': 'float_array',
        'ids': 'ids',
        'media_ids': 'media_ids',
        'media_query': 'media_query',
        'new_elemental_id': 'new_elemental_id',
        'new_version': 'new_version',
        'object_search': 'object_search',
        'state_ids': 'state_ids',
        'user_elemental_id': 'user_elemental_id'
    }

    def __init__(self, attributes=None, float_array=None, ids=None, media_ids=None, media_query=None, new_elemental_id=None, new_version=None, object_search=None, state_ids=None, user_elemental_id=None, local_vars_configuration=None):  # noqa: E501
        """LocalizationBulkUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._float_array = None
        self._ids = None
        self._media_ids = None
        self._media_query = None
        self._new_elemental_id = None
        self._new_version = None
        self._object_search = None
        self._state_ids = None
        self._user_elemental_id = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if float_array is not None:
            self.float_array = float_array
        if ids is not None:
            self.ids = ids
        if media_ids is not None:
            self.media_ids = media_ids
        if media_query is not None:
            self.media_query = media_query
        if new_elemental_id is not None:
            self.new_elemental_id = new_elemental_id
        if new_version is not None:
            self.new_version = new_version
        if object_search is not None:
            self.object_search = object_search
        if state_ids is not None:
            self.state_ids = state_ids
        if user_elemental_id is not None:
            self.user_elemental_id = user_elemental_id

    @property
    def attributes(self):
        """
        Attribute values to bulk update an entity list.

        :return: The attributes of this LocalizationBulkUpdate. 
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Attribute values to bulk update an entity list.

        :param attributes: The attributes of this LocalizationBulkUpdate.
        :type: dict(str, object)
        """

        self._attributes = attributes

    @property
    def float_array(self):
        """
        Searches on `float_array` attributes.

        :return: The float_array of this LocalizationBulkUpdate. 
        :rtype: list[FloatArrayQuery]
        """
        return self._float_array

    @float_array.setter
    def float_array(self, float_array):
        """
        Searches on `float_array` attributes.

        :param float_array: The float_array of this LocalizationBulkUpdate.
        :type: list[FloatArrayQuery]
        """

        self._float_array = float_array

    @property
    def ids(self):
        """
        Array of localization IDs to retrieve.

        :return: The ids of this LocalizationBulkUpdate. 
        :rtype: list[int]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """
        Array of localization IDs to retrieve.

        :param ids: The ids of this LocalizationBulkUpdate.
        :type: list[int]
        """

        self._ids = ids

    @property
    def media_ids(self):
        """
        Array of parent media IDs for which localizations should be retrieved.

        :return: The media_ids of this LocalizationBulkUpdate. 
        :rtype: list[int]
        """
        return self._media_ids

    @media_ids.setter
    def media_ids(self, media_ids):
        """
        Array of parent media IDs for which localizations should be retrieved.

        :param media_ids: The media_ids of this LocalizationBulkUpdate.
        :type: list[int]
        """

        self._media_ids = media_ids

    @property
    def media_query(self):
        """
        Query string used to filter media IDs. This can be used to avoid serialization and download of a media ID list.

        :return: The media_query of this LocalizationBulkUpdate. 
        :rtype: str
        """
        return self._media_query

    @media_query.setter
    def media_query(self, media_query):
        """
        Query string used to filter media IDs. This can be used to avoid serialization and download of a media ID list.

        :param media_query: The media_query of this LocalizationBulkUpdate.
        :type: str
        """

        self._media_query = media_query

    @property
    def new_elemental_id(self):
        """
        The new elemental ID for these objects

        :return: The new_elemental_id of this LocalizationBulkUpdate. 
        :rtype: str
        """
        return self._new_elemental_id

    @new_elemental_id.setter
    def new_elemental_id(self, new_elemental_id):
        """
        The new elemental ID for these objects

        :param new_elemental_id: The new_elemental_id of this LocalizationBulkUpdate.
        :type: str
        """

        self._new_elemental_id = new_elemental_id

    @property
    def new_version(self):
        """
        Unique integer identifying a new version for these objects

        :return: The new_version of this LocalizationBulkUpdate. 
        :rtype: int
        """
        return self._new_version

    @new_version.setter
    def new_version(self, new_version):
        """
        Unique integer identifying a new version for these objects

        :param new_version: The new_version of this LocalizationBulkUpdate.
        :type: int
        """

        self._new_version = new_version

    @property
    def object_search(self):
        """

        :return: The object_search of this LocalizationBulkUpdate. 
        :rtype: AttributeOperationSpec
        """
        return self._object_search

    @object_search.setter
    def object_search(self, object_search):
        """

        :param object_search: The object_search of this LocalizationBulkUpdate.
        :type: AttributeOperationSpec
        """

        self._object_search = object_search

    @property
    def state_ids(self):
        """
        Array of parent state IDs for which localizations should be retrieved.

        :return: The state_ids of this LocalizationBulkUpdate. 
        :rtype: list[int]
        """
        return self._state_ids

    @state_ids.setter
    def state_ids(self, state_ids):
        """
        Array of parent state IDs for which localizations should be retrieved.

        :param state_ids: The state_ids of this LocalizationBulkUpdate.
        :type: list[int]
        """

        self._state_ids = state_ids

    @property
    def user_elemental_id(self):
        """
        Unique ID of the original user who created this. If permissions allow, will change the creating user to the one referenced by this elemental_id

        :return: The user_elemental_id of this LocalizationBulkUpdate. 
        :rtype: str
        """
        return self._user_elemental_id

    @user_elemental_id.setter
    def user_elemental_id(self, user_elemental_id):
        """
        Unique ID of the original user who created this. If permissions allow, will change the creating user to the one referenced by this elemental_id

        :param user_elemental_id: The user_elemental_id of this LocalizationBulkUpdate.
        :type: str
        """

        self._user_elemental_id = user_elemental_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LocalizationBulkUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LocalizationBulkUpdate):
            return True

        return self.to_dict() != other.to_dict()
