# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class NotifySpec(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'message': 'str',
        'send_as_file': 'int'
    }

    attribute_map = {
        'message': 'message',
        'send_as_file': 'send_as_file'
    }

    def __init__(self, message=None, send_as_file=None, local_vars_configuration=None):  # noqa: E501
        """NotifySpec - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._message = None
        self._send_as_file = None
        self.discriminator = None

        self.message = message
        if send_as_file is not None:
            self.send_as_file = send_as_file

    @property
    def message(self):
        """
        Message to send to administrators.

        :return: The message of this NotifySpec. 
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """
        Message to send to administrators.

        :param message: The message of this NotifySpec.
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and message is None:  # noqa: E501
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    @property
    def send_as_file(self):
        """
        Whether to send message as a file. (0 or 1)

        :return: The send_as_file of this NotifySpec. 
        :rtype: int
        """
        return self._send_as_file

    @send_as_file.setter
    def send_as_file(self, send_as_file):
        """
        Whether to send message as a file. (0 or 1)

        :param send_as_file: The send_as_file of this NotifySpec.
        :type: int
        """

        self._send_as_file = send_as_file

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotifySpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NotifySpec):
            return True

        return self.to_dict() != other.to_dict()
