# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class StateBulkDelete(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'float_array': 'list[FloatArrayQuery]',
        'ids': 'list[int]',
        'localization_ids': 'list[int]',
        'media_ids': 'list[int]',
        'media_query': 'str',
        'object_search': 'AttributeOperationSpec',
        'prune': 'int'
    }

    attribute_map = {
        'float_array': 'float_array',
        'ids': 'ids',
        'localization_ids': 'localization_ids',
        'media_ids': 'media_ids',
        'media_query': 'media_query',
        'object_search': 'object_search',
        'prune': 'prune'
    }

    def __init__(self, float_array=None, ids=None, localization_ids=None, media_ids=None, media_query=None, object_search=None, prune=0, local_vars_configuration=None):  # noqa: E501
        """StateBulkDelete - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._float_array = None
        self._ids = None
        self._localization_ids = None
        self._media_ids = None
        self._media_query = None
        self._object_search = None
        self._prune = None
        self.discriminator = None

        if float_array is not None:
            self.float_array = float_array
        if ids is not None:
            self.ids = ids
        if localization_ids is not None:
            self.localization_ids = localization_ids
        if media_ids is not None:
            self.media_ids = media_ids
        if media_query is not None:
            self.media_query = media_query
        if object_search is not None:
            self.object_search = object_search
        if prune is not None:
            self.prune = prune

    @property
    def float_array(self):
        """
        Searches on `float_array` attributes.

        :return: The float_array of this StateBulkDelete. 
        :rtype: list[FloatArrayQuery]
        """
        return self._float_array

    @float_array.setter
    def float_array(self, float_array):
        """
        Searches on `float_array` attributes.

        :param float_array: The float_array of this StateBulkDelete.
        :type: list[FloatArrayQuery]
        """

        self._float_array = float_array

    @property
    def ids(self):
        """
        Array of state IDs to retrieve.

        :return: The ids of this StateBulkDelete. 
        :rtype: list[int]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """
        Array of state IDs to retrieve.

        :param ids: The ids of this StateBulkDelete.
        :type: list[int]
        """

        self._ids = ids

    @property
    def localization_ids(self):
        """
        Array of child localization IDs for which states should be retrieved.

        :return: The localization_ids of this StateBulkDelete. 
        :rtype: list[int]
        """
        return self._localization_ids

    @localization_ids.setter
    def localization_ids(self, localization_ids):
        """
        Array of child localization IDs for which states should be retrieved.

        :param localization_ids: The localization_ids of this StateBulkDelete.
        :type: list[int]
        """

        self._localization_ids = localization_ids

    @property
    def media_ids(self):
        """
        Array of parent media IDs for which states should be retrieved.

        :return: The media_ids of this StateBulkDelete. 
        :rtype: list[int]
        """
        return self._media_ids

    @media_ids.setter
    def media_ids(self, media_ids):
        """
        Array of parent media IDs for which states should be retrieved.

        :param media_ids: The media_ids of this StateBulkDelete.
        :type: list[int]
        """

        self._media_ids = media_ids

    @property
    def media_query(self):
        """
        Query string used to filter media IDs. This can be used to avoid serialization and download of a media ID list.

        :return: The media_query of this StateBulkDelete. 
        :rtype: str
        """
        return self._media_query

    @media_query.setter
    def media_query(self, media_query):
        """
        Query string used to filter media IDs. This can be used to avoid serialization and download of a media ID list.

        :param media_query: The media_query of this StateBulkDelete.
        :type: str
        """

        self._media_query = media_query

    @property
    def object_search(self):
        """

        :return: The object_search of this StateBulkDelete. 
        :rtype: AttributeOperationSpec
        """
        return self._object_search

    @object_search.setter
    def object_search(self, object_search):
        """

        :param object_search: The object_search of this StateBulkDelete.
        :type: AttributeOperationSpec
        """

        self._object_search = object_search

    @property
    def prune(self):
        """
        If set to 1 will purge the object from the database entirely. This removes any record, change-log, that this metadatum ever existed.

        :return: The prune of this StateBulkDelete. 
        :rtype: int
        """
        return self._prune

    @prune.setter
    def prune(self, prune):
        """
        If set to 1 will purge the object from the database entirely. This removes any record, change-log, that this metadatum ever existed.

        :param prune: The prune of this StateBulkDelete.
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                prune is not None and prune > 1):  # noqa: E501
            raise ValueError("Invalid value for `prune`, must be a value less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                prune is not None and prune < 0):  # noqa: E501
            raise ValueError("Invalid value for `prune`, must be a value greater than or equal to `0`")  # noqa: E501

        self._prune = prune

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StateBulkDelete):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StateBulkDelete):
            return True

        return self.to_dict() != other.to_dict()
